<?
/*   search.php3 v.2.0.4 for UdmSearch 2.0
 *   by UdmSearch Developers Team
 */
$db='udmsearch';
$dbhost='localhost';
$dbuser='foo';
$dbpasswd='bar';
$self='search.php3';

function print_header($title){
    echo "<HTML><HEAD>\n <TITLE>$title</TITLE>\n</HEAD>\n<BODY BGCOLOR=\"#EEEEEE\">\n";
}

function exit_footer($msg=''){
    echo $msg;
    echo "\n</BODY>\n</HTML>\n";
    exit;
}

if (isset($s)){
    $s1=htmlspecialchars($s);
    print_header('Search: results');
}
else{
    $s1="";
    print_header('Search');
}

// Print search form
?>
<FORM METHOD=GET ACTION="<? echo $self; ?>">
<INPUT TYPE=TEXT NAME="s" SIZE=60 VALUE="<? echo $s1; ?>">
<INPUT TYPE=SUBMIT VALUE="Search">
</FORM>
<HR>
<?

function ParseStr($qwe){
  $qwe=strtr($qwe,'','');

  $qwe=ereg_replace("[^ &|~()0123456789abcdeffhigklmnopqrstuvwxyzABCDEFGHIGKLMNOPQRSTUVWXYZ]{1,}","&",$qwe);
  $qwe=ereg_replace("^ {0,}","",$qwe);
  $qwe=ereg_replace(" {0,}\| {0,}","|",$qwe);
  $qwe=ereg_replace(" {0,}\& {0,}","&",$qwe);
  $qwe=ereg_replace(" {0,}\( {0,}","(",$qwe);
  $qwe=ereg_replace(" {0,}\) {0,}",")",$qwe);
  $qwe=ereg_replace(" {0,}\~ {0,}","~",$qwe);
  $qwe=ereg_replace(" {1,}","|",$qwe);
  $qwe=ereg_replace("\|{1,}","|",$qwe);
  $qwe=ereg_replace("&{1,}","&",$qwe);  
  $qwe=ereg_replace("\|\&\|","&",$qwe);
  $qwe=ereg_replace("[\|\&]{1,}$","",$qwe);
  $qwe=ereg_replace("^[\|\&]{1,}","",$qwe);
  return($qwe);
}

if(!isset($s)) exit_footer();

$query_orig=$s;

$s=ParseStr($s);
echo "<CENTER>Query:'$s'</CENTER><BR>\n";

$s=ereg_replace("\&"," && ",$s);
$s=ereg_replace("\|"," || ",$s);
$s=ereg_replace("\~"," ! ",$s);
$s=ereg_replace("\("," ( ",$s);
$s=ereg_replace("\)"," ) ",$s);
$s="( $s )"; 
$s=ereg_replace(" {1,}"," ",$s);
$q="";
$w=""; 
$state=0; 
$n=0;

$t=strtok($s," ");

while(($t!="")&&($error=="")){

  switch($state){
    case 0;  
    if(($t=="||")||($t=="&&")||($t==")"))
      $error="at '$t'";
    else if($t=="!"){
      $state=0;
      $q="$q ! ";
    }
    else if($t=="("){
      $n++;
      $state=0;
      $q="$q(";
    }
    else {
      $q="$q sum(dict.word='$t')";
      if($w=="")
	$w="'$t'";
      else
	$w="$w,'$t'";
      $state=1;
    }
    break;
    
    case 1;  
    if(($t=="||")||($t=="&&")){
      $state=0;
      $q="$q $t";
    }
    else if($t==")"){
      $n--;
      $state=1;
      $q="$q)";
    }
    else
      $error=" at '$t'";
    break;
  }
  $t=strtok(" ");
}

if($error==""&&$n!=0)
  $error='Unmatched brackets';

if($error!="") exit_footer("Error in query: $error\n");

if (!mysql_pconnect($dbhost,$dbuser,$dbpasswd)) exit_footer('<BR>Connection Error');

$query="SELECT ($q)as q FROM dict WHERE dict.word in ($w) GROUP BY url_id HAVING q>0";
if (!($res=@mysql($db,$query))) exit_footer('<BR>Query error: '.$query."\n<BR>".mysql_error());

$found=mysql_numrows($res);
mysql_FreeResult($res);

if($ps=="")
  $ps=20;
if($np=="")
  $np=0;

$from=IntVal($np)*IntVal($ps); 
$from1=IntVal($from)+1;
$to=IntVal($np+1)*IntVal($ps); 
$ps1=IntVal($ps)+1;
if($to>$found)
  $to=IntVal($found);

$ps_next=$found-$to;
if (($ps_next>$ps) || ($ps_next<0))
    $ps_next=$ps;

if($found>0)
  echo "<CENTER>Documents $from1-$to from $found found</CENTER><HR>";
else exit_footer('<CENTER>No documents found.</CENTER>');

$query="SELECT dict.url_id,sum(dict.word in ($w))as r,($q)as q FROM dict WHERE dict.word in ($w) GROUP BY url_id HAVING q>0 ORDER BY r DESC LIMIT $from,$ps1";
if (!($res=@mysql($db,$query))) exit_footer ('<BR>Query error: '.$query."\n<BR>".mysql_error());

$rows=mysql_numrows($res); 
$i=0;
if($rows>$ps){
 $rows=$ps;
 $isnext=1;
}

while($i<$rows){
  $url_id = mysql_result($res,$i++,"url_id");
  if($url_in=="")
    $url_in="$url_id";
  else	
    $url_in.=",$url_id";
}
mysql_FreeResult($res);

if($url_in!=""){
  $query="SELECT url.url,url.title,url.text,url.content_type,url.size,url.last_modified,dict.url_id,sum(dict.word in ($w))as r,($q)as q FROM dict,url WHERE dict.word in ($w) AND dict.url_id in ($url_in) AND dict.url_id=url.rec_id GROUP BY url_id HAVING q>0 ORDER BY r DESC";
  if (!($res=@mysql($db,$query))) exit_footer('<BR>Query error: '.$query."\n<BR>".mysql_error());

  echo "<TABLE>\n";
  $ndoc=$from+1;
  while($data=mysql_fetch_array($res)){
    $title=$data[title];
    $title=($title) ? htmlspecialChars($title):'No title';
    $text=htmlspecialChars($data[text]);
    echo "<TR><TD>$ndoc) <A HREF=\"$data[url]\" TARGET=\"_blank\"><B><I>$title</I></B></A> [$data[r]]<DD><SMALL>$text...<BR>\n<A HREF=\"$data[url]\" TARGET=\"_blank\">$data[url]</A> ($data[content_type]) $data[last_modified], Size: $data[size] bytes</SMALL><BR><BR></TD></TR>\n";
    $ndoc++;
  }
  mysql_FreeResult($res);
  echo "</TABLE>\n";
}
?>

<HR>
<CENTER>

<?
$s=ereg_replace(" ","+",$query_orig);
$s=ereg_replace("&","%26",$s);
if($np>0){
  $prevp=$np-1;
  echo "<A HREF=\"$self?s=$s&np=$prevp\">&lt;&lt; Prev $ps</A>&nbsp;&nbsp;";
}
if($isnext==1){
  $nextp=$np+1;
  echo "<A HREF=\"$self?s=$s&np=$nextp\">Next $ps_next &gt;&gt;</A>";
}
?>
</CENTER>
<?
    exit_footer();
?>
