#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include "openhost.h"


int open_host(char *hostname,int port)
{
int net;
struct hostent *host;
struct sockaddr_in sin;

 bzero( (char*)&sin, sizeof(sin) );
 if ((sin.sin_addr.s_addr=inet_addr(hostname)) != (unsigned long) -1)
   sin.sin_family=AF_INET;
 else
   if (host=gethostbyname(hostname) ) {
     sin.sin_family=host->h_addrtype;
     memcpy((caddr_t)&sin.sin_addr, host->h_addr, host->h_length);
   } else return(-1);
 
 if (port) sin.sin_port= htons(port);
 else
   return(-2);

 net=socket(AF_INET, SOCK_STREAM, 0);
 connect(net, (struct sockaddr *)&sin, sizeof (sin));
 return(net);
}
